---
title: Feature-Policy
slug: Web/HTTP/Headers/Feature-Policy
tags:
  - Authorization
  - Experimental
  - Feature Policy
  - Feature-Policy
  - HTTP
  - Permissions
  - Reference
  - Security
  - Web
  - header
---
<div>{{HTTPSidebar}}</div>

<p><span class="seoSummary">The HTTP <strong><code>Feature-Policy</code></strong> header provides a mechanism to allow and deny the use of browser features in its own frame, and in content within any {{HTMLElement("iframe")}} elements in the document.</span></p>

<div class="note">
<p>This header is still in an experimental state, and is subject to change at any time. Be wary of this when implementing it on your website. The header has now been renamed to <code>Permissions-Policy</code> in the spec, and this article will eventually be updated to reflect that change.</p>
</div>

<p>For more information, see the main <a href="/docs/Web/HTTP/Feature_Policy">Feature Policy</a> article.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Header type</th>
   <td>{{Glossary("Response header")}}</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Forbidden header name")}}</th>
   <td>yes</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Feature-Policy: &lt;directive&gt; &lt;allowlist&gt;</pre>

<dl>
 <dt><code>&lt;directive&gt;</code></dt>
 <dd>The Feature Policy directive to apply the <code>allowlist</code> to. See {{anch("Directives")}} below for a list of the permitted directive names.</dd>
 <dt><code>&lt;allowlist&gt;</code></dt>
 <dd>{{page("Web/HTTP/Feature_Policy/Using_Feature_Policy", "allowlist")}}</dd>
</dl>

<h2 id="Directives">Directives</h2>

<dl>
 <dt>{{httpheader('Feature-Policy/accelerometer','accelerometer')}}</dt>
 <dd>Controls whether the current document is allowed to gather information about the acceleration of the device through the {{DOMxRef("Accelerometer")}} interface.</dd>
 <dt>{{httpheader('Feature-Policy/ambient-light-sensor','ambient-light-sensor')}}</dt>
 <dd>Controls whether the current document is allowed to gather information about the amount of light in the environment around the device through the {{DOMxRef("AmbientLightSensor")}} interface.</dd>
 <dt>{{httpheader('Feature-Policy/autoplay','autoplay')}}</dt>
 <dd>Controls whether the current document is allowed to autoplay media requested through the {{domxref("HTMLMediaElement")}} interface. When this policy is disabled and there were no user gestures, the {{jsxref("Promise")}} returned by {{domxref("HTMLMediaElement.play()")}} will reject with a {{domxref("DOMException")}}. The autoplay attribute on {{HTMLELement("audio")}} and {{HTMLElement("video")}} elements will be ignored.</dd>
 <dt>{{httpheader('Feature-Policy/battery','battery')}}</dt>
 <dd>Controls whether the use of the <a href="/docs/Web/API/Battery_Status_API">Battery Status API</a> is allowed. When this policy is disabled, the {{JSxRef("Promise")}} returned by {{DOMxRef("Navigator.getBattery","Navigator.getBattery()")}} will reject with a {{Exception("NotAllowedError")}} {{DOMxRef("DOMException")}}.</dd>
 <dt>{{httpheader('Feature-Policy/camera', 'camera')}}</dt>
 <dd>Controls whether the current document is allowed to use video input devices. When this policy is disabled, the {{jsxref("Promise")}} returned by {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}} will reject with a {{Exception("NotAllowedError")}} {{DOMxRef("DOMException")}}.</dd>
 <dt>{{HTTPHeader('Feature-Policy/display-capture', 'display-capture')}}</dt>
 <dd>Controls whether or not the current document is permitted to use the {{domxref("MediaDevices.getDisplayMedia", "getDisplayMedia()")}} method to capture screen contents. When this policy is disabled, the promise returned by <code>getDisplayMedia()</code> will reject with a {{Exception("NotAllowedError")}} if permission is not obtained to capture the display's contents.</dd>
 <dt>{{httpheader('Feature-Policy/document-domain','document-domain')}}</dt>
 <dd>Controls whether the current document is allowed to set {{domxref("document.domain")}}. When this policy is disabled, attempting to set {{domxref("document.domain")}} will fail and cause a {{Exception("SecurityError")}} {{domxref("DOMException")}} to be thrown.</dd>
 <dt>{{httpheader('Feature-Policy/encrypted-media', 'encrypted-media')}}</dt>
 <dd>Controls whether the current document is allowed to use the <a href="/en-US/docs/Web/API/Encrypted_Media_Extensions_API">Encrypted Media Extensions</a> API (EME). When this policy is disabled, the {{jsxref("Promise")}} returned by {{domxref("Navigator.requestMediaKeySystemAccess()")}} will reject with a {{domxref("DOMException")}}.</dd>
 <dt>{{httpheader('Feature-Policy/execution-while-not-rendered', 'execution-while-not-rendered')}}</dt>
 <dd>Controls whether tasks should execute in frames while they're not being rendered (e.g. if an iframe is <code><a href="/en-US/docs/Web/HTML/Global_attributes/hidden">hidden</a></code> or <code>display: none</code>).</dd>
 <dt>{{httpheader('Feature-Policy/execution-while-out-of-viewport', 'execution-while-out-of-viewport')}}</dt>
 <dd>Controls whether tasks should execute in frames while they're outside of the visible viewport.</dd>
</dl>

<dl>
 <dt>{{httpheader('Feature-Policy/fullscreen','fullscreen')}}</dt>
 <dd>Controls whether the current document is allowed to use {{DOMxRef("Element.requestFullScreen()")}}. When this policy is disabled, the returned {{JSxRef("Promise")}} rejects with a {{JSxRef("TypeError")}}.</dd>
 <dt>{{httpheader('Feature-Policy/geolocation','geolocation')}}</dt>
 <dd>Controls whether the current document is allowed to use the {{domxref('Geolocation')}} Interface. When this policy is disabled, calls to {{domxref('Geolocation.getCurrentPosition','getCurrentPosition()')}} and {{domxref('Geolocation.watchPosition','watchPosition()')}} will cause those functions' callbacks to be invoked with a {{domxref('PositionError')}} code of <code>PERMISSION_DENIED</code>.</dd>
 <dt>{{httpheader('Feature-Policy/gyroscope','gyroscope')}}</dt>
 <dd>Controls whether the current document is allowed to gather information about the orientation of the device through the {{DOMxRef("Gyroscope")}} interface.</dd>
 <dt>{{httpheader('Feature-Policy/layout-animations','layout-animations')}}</dt>
 <dd>Controls whether the current document is allowed to show layout animations.</dd>
</dl>

<dl>
 <dt>{{httpheader('Feature-Policy/legacy-image-formats','legacy-image-formats')}}</dt>
 <dd>Controls whether the current document is allowed to display images in legacy formats.</dd>
</dl>

<dl>
 <dt>{{httpheader('Feature-Policy/magnetometer','magnetometer')}}</dt>
 <dd>Controls whether the current document is allowed to gather information about the orientation of the device through the {{DOMxRef("Magnetometer")}} interface.</dd>
 <dt>{{httpheader('Feature-Policy/microphone','microphone')}}</dt>
 <dd>Controls whether the current document is allowed to use audio input devices. When this policy is disabled, the {{jsxref("Promise")}} returned by {{domxref("MediaDevices.getUserMedia()")}} will reject with a {{Exception("NotAllowedError")}}.</dd>
 <dt>{{httpheader('Feature-Policy/midi', 'midi')}}</dt>
 <dd>Controls whether the current document is allowed to use the <a href="/en-US/docs/Web/API/Web_MIDI_API">Web MIDI API</a>. When this policy is disabled, the {{jsxref("Promise")}} returned by {{domxref("Navigator.requestMIDIAccess()")}} will reject with a {{domxref("DOMException")}}.</dd>
 <dt>{{httpheader('Feature-Policy/navigation-override','navigation-override')}}</dt>
 <dd>Controls the availability of mechanisms that enables the page author to take control over the behavior of <a href="https://www.w3.org/TR/css-nav/">spatial navigation</a>, or to cancel it outright.</dd>
 <dt>{{httpheader('Feature-Policy/oversized-images','oversized-images')}}</dt>
 <dd>Controls whether the current document is allowed to download and display large images.</dd>
 <dt>{{httpheader('Feature-Policy/payment', 'payment')}}</dt>
 <dd>Controls whether the current document is allowed to use the <a href="/en-US/docs/Web/API/Payment_Request_API">Payment Request API</a>. When this policy is enabled, the {{domxref("PaymentRequest","PaymentRequest()")}} constructor will throw a {{Exception("SecurityError")}} {{domxref("DOMException")}}.</dd>
 <dt>{{httpheader('Feature-Policy/picture-in-picture', 'picture-in-picture')}}</dt>
 <dd>Controls whether the current document is allowed to play a video in a Picture-in-Picture mode via the corresponding API.</dd>
 <dt>{{httpheader("Feature-Policy/publickey-credentials-get", "publickey-credentials-get")}}</dt>
 <dd>Controls whether the current document is allowed to use the <a href="/en-US/docs/Web/API/Web_Authentication_API">Web Authentication API</a> to retreive already stored public-key credentials, i.e. via {{domxref("CredentialsContainer.get","navigator.credentials.get({publicKey: ..., ...})")}}.</dd>
 <dt>{{httpheader('Feature-Policy/sync-xhr', 'sync-xhr')}}</dt>
 <dd>Controls whether the current document is allowed to make synchronous {{DOMxRef("XMLHttpRequest")}} requests.</dd>
 <dt>{{httpheader('Feature-Policy/usb', 'usb')}}</dt>
 <dd>Controls whether the current document is allowed to use the <a href="https://wicg.github.io/webusb/">WebUSB API</a>.</dd>
 <dt>{{httpheader('Feature-Policy/vr', 'vr')}} {{deprecated_inline}}</dt>
 <dd>Controls whether the current document is allowed to use the <a href="/en-US/docs/Web/API/WebVR_API">WebVR API</a>. When this policy is disabled, the {{jsxref("Promise")}} returned by {{domxref("Navigator.getVRDisplays","Navigator.getVRDisplays()")}} will reject with a {{domxref("DOMException")}}. Keep in mind that the WebVR standard is in the process of being replaced with <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR</a>.</dd>
 <dt>{{httpheader('Feature-Policy/wake-lock', 'wake-lock')}}</dt>
 <dd>Controls whether the current document is allowed to use <a href="https://www.w3.org/TR/wake-lock/">Wake Lock API</a> to indicate that device should not enter power-saving mode.</dd>
 <dt>{{httpheader('Feature-Policy/screen-wake-lock', 'screen-wake-lock')}}</dt>
 <dd>Controls whether the current document is allowed to use <a href="/en-US/docs/Web/API/Screen_Wake_Lock_API">Screen Wake Lock API</a> to indicate that device should not turn off or dim the screen.</dd>
 <dt>{{httpheader("Feature-Policy/web-share", "web-share")}}</dt>
 <dd>Controls whether or not the current document is allowed to use the {{domxref("Navigator.share","Navigator.share()")}} of Web Share API to share text, links, images, and other content to arbitrary destinations of user's choice, e.g. mobile apps.</dd>
 <dt>{{httpheader("Feature-Policy/xr-spatial-tracking", "xr-spatial-tracking")}}</dt>
 <dd>Controls whether or not the current document is allowed to use the <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a> to interact with a WebXR session.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>SecureCorp Inc. wants to disable Microphone and Geolocation APIs in its application. It can do so by delivering the following HTTP response header to define a feature policy:</p>

<pre class="notranslate">Feature-Policy: microphone 'none'; geolocation 'none'</pre>

<p>By specifying the <code>'none'</code> keyword for the origin list, the specified features will be disabled for all browsing contexts (this includes all iframes), regardless of their origin.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><a href="https://w3c.github.io/webappsec-permissions-policy/#permissions-policy-http-header-field">Permissions Policy</a></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("http.headers.Feature-Policy")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/HTTP/Feature_Policy">Feature Policy</a></li>
 <li><a href="/en-US/docs/Web/HTTP/Feature_Policy/Using_Feature_Policy">Using Feature Policy</a></li>
 <li>{{DOMxRef("Document.featurePolicy")}} and {{DOMxRef("FeaturePolicy")}}</li>
 <li><a class="external external-icon" href="https://chrome.google.com/webstore/detail/feature-policy-tester-dev/pchamnkhkeokbpahnocjaeednpbpacop" rel="noopener">Feature-Policy Tester (Chrome Developer Tools extension)</a></li>
 <li>{{HTTPHeader("Content-Security-Policy")}}</li>
 <li>{{HTTPHeader("Referrer-Policy")}}</li>
</ul>
